/*********************************************************************
 * Capítulo 2. Entorno de Trabajo.
 * Programación Multimedia y Juegos
 * Autor: David Vallejo Fernández    david.vallejo@openflbook.com
 * Autor: Carlos González Morcillo   carlos.gonzalez@openflbook.com
 * Autor: David Frutos Talavera      david.frutos@openflbook.com
 *
 * You can redistribute and/or modify this file under the terms of the
 * GNU General Public License ad published by the Free Software
 * Foundation, either version 3 of the License, or (at your option)
 * and later version. See <http://www.gnu.org/licenses/>.
 *
 * This file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.  
 *********************************************************************/

package book.openfl.holaMundo;

import flash.display.Sprite;
import flash.events.Event;
import flash.Lib;
import flash.display.Bitmap;
import flash.media.Sound;
import motion.Actuate;
import motion.easing.Elastic;
import openfl.Assets;

/****************************************
 * Código fuente adaptado de 
 * http://www.nme.io/developers/tutorials
 * Autor Original: Joshua Granick
 ****************************************/

class Main extends Sprite 
{
	var inited:Bool;
	var logo:Bitmap;
	var sound:Sound;
	
	/* ENTRY POINT */
	
	
	  /* Movimiento aleatorio del logo */
	  private function moveLogo ():Void {		
		var randomX = Math.random () * (stage.stageWidth - logo.width);
		var randomY = Math.random () * (stage.stageHeight - logo.height);
		Actuate.tween (logo, 2, { x: randomX, y: randomY } ).ease (Elastic.easeOut).onComplete (moveLogo);		
	  }
	
	function resize(e) 
	{
		if (!inited) init();
		// else (resize or orientation change)
	}
	
	function init() 
	{
		if (inited) return;
		inited = true;

		/* Carga el logo */
		logo = new Bitmap (Assets.getBitmapData ("img/tegnix.png"));
			
		/* Centra el logo en el centro de la pantalla con transparencia a 0*/
		logo.x = (stage.stageWidth - logo.width) / 2;
		logo.y = (stage.stageHeight - logo.height) / 2;
		logo.alpha = 0;
			
		/* Añade el logo a la display list */ 
		addChild (logo);

		/* Obtiene el sonido y lo reproduce*/
		#if flash
		sound = Assets.getSound ("music/stars.mp3");
		#else
		sound = Assets.getSound ("music/stars.ogg");
		#end
		sound.play ();
			
		/* Delega la animación en la biblioteca Actuate */
		Actuate.tween (logo, 2, { alpha: 1 } ).onComplete (moveLogo);	
	}

	/* SETUP */

	public function new() 
	{
		super();	
		addEventListener(Event.ADDED_TO_STAGE, added);
	}
	
	/* Manejadores de eventos*/
	function added(e) 
	{
		removeEventListener(Event.ADDED_TO_STAGE, added);
		stage.addEventListener(Event.RESIZE, resize);
		#if ios
		haxe.Timer.delay(init, 100); // iOS 6
		#else
		init();
		#end
	}
	
	  /* Punto de entrada */
	
	public static function main() 
	{
		// static entry point
		Lib.current.stage.align = flash.display.StageAlign.TOP_LEFT;
		Lib.current.stage.scaleMode = flash.display.StageScaleMode.NO_SCALE;
		Lib.current.addChild(new Main());
	}
}
